package kafka.reactive.producerAvro.kafkareactiveproducerAvro;

import com.genericAvro.PersonData;
import io.confluent.kafka.serializers.KafkaAvroSerializer;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.common.serialization.StringSerializer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

@Configuration
public class KafkaProducerConfig {

    @Bean
    public Producer<String, PersonData> getProducer() {
        Properties properties = new Properties();
        // Kafka Properties
        properties.setProperty("bootstrap.servers", IKafkaConstants.KAFKA_SERVER);
        properties.setProperty("acks", "all");
        properties.setProperty("retries", "10");
        // Avro properties
        properties.setProperty("key.serializer", StringSerializer.class.getName());
        properties.setProperty("value.serializer", KafkaAvroSerializer.class.getName());
        properties.setProperty("schema.registry.url", IKafkaConstants.SCHEMA_REGISTRY_URL);
        Producer<String, PersonData> producer = new KafkaProducer<String, PersonData>(properties);
        return producer;
    }


    /*@Bean
    public ProducerFactory<String, PersonData> producerFactory() {
        Map<String, Object> config = new HashMap<>();
        config.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, IKafkaConstants.KAFKA_SERVER);
        config.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, StringSerializer.class);
        config.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, KafkaAvroSerializer.class);
        config.put(IKafkaConstants.SCHEMA_REGISTRY_URL, "http://127.0.0.1:8081");
        return new DefaultKafkaProducerFactory<>(config);
    }

    @Bean
    public KafkaTemplate<String, PersonData> kafkaTemplate() {
        return new KafkaTemplate<String, PersonData>(producerFactory());
    }*/
}
